function [U,R] = grouse_iter(U,R,W,iter,C)

[n, m] = size(U);

% Pull out translation vector
t = R(:,end);

r = zeros(n,1);
for curr_frame = randperm(size(W,2));

    v = W(:,curr_frame);
    omega = find(~isnan(v));
    v_omega = v(omega);
    U(:,m) = 1/sqrt(n);
    U_omega = U(omega,:);
        
    % Remove the current frame's data
    R(curr_frame,:) = 0;
    t(curr_frame) = 0;
    
    % Update!
    w = U_omega\v_omega;

    r = 0*r;
    r(omega) = v_omega - U_omega*w;
    
    t(curr_frame) = w(end)/sqrt(n);
    
    [uu,ss,vv] = svd([eye(m-1) w(1:end-1); zeros(1,m-1) norm(r * C/(C+iter-1))]);
    R(:,m) = 0;
    R(curr_frame,m) = 1;
    R = R*vv*ss';
    U(:,m) = r/norm(r);
    U = U*uu;    
end

U(:,m) = ones(n,1);
R(:,m) = t;




